format PE Console at 400000h
include 'encoding\win1251.inc'
include 'win32w.inc'

SimulationMode=0 ;  0 - , 1 - .      NCStudio.     DrvSimu.dll, MFS42.dll, MSVCRT.dll

DIGCF_PRESENT                    =2;
DIGCF_DEVICEINTERFACE            =16;
SPDRP_FRIENDLYNAME               =12;
SPDRP_PHYSICAL_DEVICE_OBJECT_NAME=14;

struct SP_DEVINFO_DATA
  cbSize     rd 1
  ClassGuid  rb 16
  DevInst    rd 1
  Reserved   rd 1
ends

struct SP_DEVICE_INTERFACE_DATA
  cbSize              rd 1
  InterfaceClassGuid  rb 16
  Flags               rd 1
  Reserved            rd 1
ends

struct SP_DEVICE_INTERFACE_DETAIL_DATA_W
  cbSize     rd 1
  DevicePath rw 4096
ends

align 16
data resource from '1.res'
end data

include 'NCStudio.inc'

align 16
entry $
  invoke SetupDiGetClassDevsW,GUID_NCStudio,0,0,DIGCF_DEVICEINTERFACE+DIGCF_PRESENT
  mov    ebx,eax
  invoke SetupDiEnumDeviceInterfaces,ebx,0,GUID_NCStudio,0,DeviceInterfaceData
  mov    [DeviceInterfaceDetailData.cbSize],6
  invoke SetupDiGetDeviceInterfaceDetailW,ebx,DeviceInterfaceData,DeviceInterfaceDetailData,sizeof.SP_DEVICE_INTERFACE_DETAIL_DATA_W,0,0
  invoke CreateFileW,DeviceInterfaceDetailData.DevicePath,GENERIC_WRITE+GENERIC_READ,FILE_SHARE_WRITE+FILE_SHARE_READ,0,OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,0
  mov    [NCStudioHandle],eax
  mov    esi,eax
  invoke SetupDiDestroyDeviceInfoList,ebx

  if SimulationMode=1
    invoke InstallSimuDrv
    mov    [NCStudioHandle],eax
    mov    [DeviceIoControl],SimuDeviceIoControlWrp
  end if

  invoke GetStdHandle,STD_OUTPUT_HANDLE
  mov    [con],eax
  invoke DialogBoxParamW,400000h,1,0,DialogProc,0

  invoke InitCommonControls ;   ,      comctl32.dll

JogHandler:
;   
  mov    ebx,6
  mov byte[Brake.x+7],80h
  mov byte[Brake.y+7],80h
  mov byte[Brake.z+7],80h
  mov byte[Brake.w+7],80h
  xor    edi,edi
  .GetJogDir:
     invoke SendMessageW,[hwnds.button_x_plus+ebx*4-4],BM_GETSTATE,0,0
     test   eax,BST_PUSHED
     je @f
       lea      eax,[ebx-1]
       shr      eax,1
       sbb      edx,edx
       or       edx,1
       mov      [LastDir+eax*4],edx
       mov      byte[Brake+eax*8+7],0
       or       edi,1
     @@:
     dec ebx
  jne .GetJogDir

  ; NCCMD- (  10   ,    0,005 ,   20  + 5    )
  or edi,dword[CurFreq.x+4]
  or edi,dword[CurFreq.y+4]
  or edi,dword[CurFreq.z+4]
  je .Sleep
    mov      ecx,25
    movapd   xmm0,dqword[CurFreq]
    movapd   xmm1,dqword[CurFreq+16]
    cvtpi2pd xmm2,qword[LastDir]
    cvtpi2pd xmm3,qword[LastDir+8]
    movupd   xmm4,dqword[Speed]
    movupd   xmm5,dqword[Speed+16]
    movapd   xmm6,xmm4
    movapd   xmm7,xmm5
    xorpd    xmm6,dqword[dbl_chs]
    xorpd    xmm7,dqword[dbl_chs]
    movapd   [MaxSpeed],xmm4
    movapd   [MaxSpeed+16],xmm5
    movapd   [MinSpeed],xmm6
    movapd   [MinSpeed+16],xmm7
    mov eax,4
    .MinMax:
      cmp byte[Brake+eax*8-1],0
      je @f
        mov edx,[LastDir+eax*4-4]
        shl edx,4
        mov dword[MaxSpeed+edx+16+eax*8-8],0
        mov dword[MaxSpeed+edx+16+eax*8-4],0
      @@:
      dec  eax
    jne .MinMax
    movapd   xmm4,[MaxSpeed]
    movapd   xmm5,[MaxSpeed+16]
    movapd   xmm6,[MinSpeed]
    movapd   xmm7,[MinSpeed+16]
    mulpd    xmm2,dqword[Accel]
    mulpd    xmm3,dqword[Accel+16]
    xorpd    xmm2,[Brake]
    xorpd    xmm3,[Brake+16]
    mov      eax,[NCCMD_FIFO]
    imul     edx,dword[eax],sizeof.NCCMD
    lea      edx,[eax+edx+8]
    .jog:addpd    xmm0,xmm2
         addpd    xmm1,xmm3
         minpd    xmm0,xmm4
         minpd    xmm1,xmm5
         maxpd    xmm0,xmm6
         maxpd    xmm1,xmm7
         cvtpd2pi mm0,xmm0
         cvtpd2pi mm1,xmm1
         packssdw mm0,mm0
         packssdw mm1,mm1
         movd     [edx],mm0
         movd     [edx+4],mm1
         mov      dword[edx+6],0
         mov      word[edx+10],NCCMD_Pulse
         add      edx,sizeof.NCCMD
         inc      dword[eax]
         cmp      dword[eax],NCCMD_FIFO_len
         jb @f
           mov dword[eax],0
           lea edx,[eax+8]
         @@:
    loop .jog
    movapd dqword[CurFreq],xmm0
    movapd dqword[CurFreq+16],xmm1
  .Sleep:
  invoke Sleep,100
jmp JogHandler

DialogProc:
  mov eax,[esp+8]
  cmp eax,WM_TIMER
  je .WM_TIMER
  cmp eax,WM_HSCROLL
  je .WM_HSCROLL
  cmp eax,WM_COMMAND
  je .WM_COMMAND
  cmp eax,WM_INITDIALOG
  je .WM_INITDIALOG
  cmp eax,WM_CLOSE
  je .WM_CLOSE
  xor eax,eax
  ret 16
       .WM_TIMER:;     ( ,  )
                 invoke DeviceIoControl,[NCStudioHandle],NC_GetState,0,0,OutBuf,4058h,i,0
                 pushad
                 ;     -    
                 mov    ebx,dword[OutBuf+4]
                 test   ebx,ebx
                 je .quit
                   mov edi,OutBuf+8
                   .ScanNCCMD:
                     mov     esi,[edi]
                     movzx   ecx,word[esi+8]
                     movzx   edx,word[esi+10]
                     cinvoke wsprintfA,Buf,fmt_NCCMD,dword[esi],dword[esi+4],ecx,edx
                     invoke  WriteFile,[con],Buf,eax,i,0
                     ; 
                     cmp     word[esi+10],NCCMD_OutPort
                     jne @f
                       mov    esi,[esi]
                       shr    esi,1
                       mov    eax,esi
                       and    eax,1
                       invoke SendMessageW,[hwnds.radio_z],BM_SETCHECK,eax,0
                       shr    esi,1
                       mov    eax,esi
                       and    eax,1
                       invoke SendMessageW,[hwnds.radio_x],BM_SETCHECK,eax,0
                       shr    esi,1
                       mov    eax,esi
                       and    eax,1
                       invoke SendMessageW,[hwnds.radio_y],BM_SETCHECK,eax,0
                     @@:
                     add     edi,4
                     dec     ebx
                   jne .ScanNCCMD
                 .quit:
                 ;  
                 mov      esi,12
                 @@:sub       esi,4
                    cvtsi2sd  xmm0,dword[OutBuf+402Ch+esi]
                    divsd     xmm0,[Pulse.x+esi*2]
                    cvttsd2si edx,xmm0
                    cvtsi2sd  xmm1,edx
                    subsd     xmm0,xmm1
                    mulsd     xmm0,[dbl_10000]
                    andpd     xmm0,dqword[dbl_abs]
                    cvtsd2si  eax,xmm0
                    push      eax
                    push      edx
                 jne @b
                 invoke   wsprintfA,OutBuf,fmt_Coord
                 mov      [OutBuf+eax],0
                 add      esp,32
                 popad
                 invoke   SendMessageA,[esp+16],WM_SETTEXT,0,OutBuf
                 ret 16
     .WM_HSCROLL:invoke SendMessageW,dword[esp+28],TBM_GETPOS,0,0
                 imul   eax,eax,sizeof.SpindleRevTableElement
                 mov    eax,[SpindleRevTable.RevTable+eax]
                 cmp    [SpindleRev.dword1],eax
                 je @f
                   mov    [SpindleRev.dword1],eax
                   invoke DeviceIoControl,[NCStudioHandle],NC_BypassNCCMD,SpindleRev,12,OutBuf,4,i,0
                 @@:
                 xor    eax,eax
                 ret 16
     .WM_COMMAND:mov eax,[esp+12]
                 ;   
                 cmp eax,(BN_CLICKED shl 16)+(hwnds.button_spindle-hwnds)/4+1
                 jne @f
                   invoke DeviceIoControl,[NCStudioHandle],NC_BypassNCCMD,OutPort,12,OutBuf,4,i,0
                   xor    [OutPort.dword2],1
                   mov    eax,[OutPort.dword2]
                   lea    eax,[ON_OFF+eax*8]
                   invoke SendMessageW,[hwnds.button_spindle],WM_SETTEXT,0,eax
                   ret    16
                 @@:
                 ;  
                 cmp eax,(BN_CLICKED shl 16)+(hwnds.button_apply-hwnds)/4+1
                 jne @f
                   .GetMotorConfig:
                   push ebx
                   mov  ebx,12
                   .GetEditVal:
                     invoke SendMessageA,[hwnds.edit_x_pulse+ebx*4-4],WM_GETTEXT,32,OutBuf
                     mov    [OutBuf+eax],0
                     mov    eax,OutBuf
                     call   StrToDoubleU
                     movsd  [Pulse+ebx*8-8],xmm0
                     dec    ebx
                   jne .GetEditVal
                   mov eax,32
                   .mm2pulse:
                     sub   eax,16
                     movapd xmm0,dqword[Speed+eax]
                     movapd xmm1,dqword[Accel+eax]
                     mulpd  xmm0,dqword[dbl_0005]
                     mulpd  xmm1,dqword[dbl_0000025]
                     mulpd  xmm0,dqword[Pulse+eax]
                     mulpd  xmm1,dqword[Pulse+eax]
                     movapd dqword[Speed+eax],xmm0
                     movapd dqword[Accel+eax],xmm1
                   jne .mm2pulse
                   pop  ebx
                   mov  eax,1
                   ret  16
                 @@:
                 ret 16
  .WM_INITDIALOG:push   ebx
                 mov    ebx,hwnds.count
                 @@:invoke GetDlgItem,dword[esp+12],ebx
                    mov    [hwnds+ebx*4-4],eax
                    dec    ebx
                 jne @b
                 pop    ebx
                 invoke SendMessageW,[hwnds.trackbar_spindle],TBM_SETRANGE,0,7 shl 16
                 invoke SendMessageW,[hwnds.trackbar_spindle],TBM_SETPOS,1,7
                 invoke DeviceIoControl,[NCStudioHandle],NC_Init,NCParams,0F8h,OutBuf,32,i,0
                 mov    eax,dword[OutBuf+12]
                 mov    [NCCMD_FIFO],eax
                 invoke DeviceIoControl,[NCStudioHandle],NC_SetSpindleRevTable,SpindleRevTable,0E0h,OutBuf,4,i,0
                 invoke DeviceIoControl,[NCStudioHandle],NC_BypassNCCMD,SpindlePercent,12,OutBuf,4,i,0
                 invoke DeviceIoControl,[NCStudioHandle],NC_BypassNCCMD,SpindleRev,12,OutBuf,4,i,0
                 invoke CreateThread,0,0,JogHandler,0,0,0
                 invoke SetTimer,dword[esp+16],1,100,0
                 jmp    .GetMotorConfig
       .WM_CLOSE:invoke DeviceIoControl,[NCStudioHandle],NC_ReleaseDevice,0,0,OutBuf,4,i,0
                 invoke CloseHandle,esi
                 invoke ExitProcess,0

StrToUInt: ;(s: PAnsiChar): Cardinal;register;
  mov edx,eax
  xor eax,eax
  xor ecx,ecx
  jmp .s
  @@:lea  eax,[eax*4+eax]
     lea  eax,[eax*2+ecx-'0']
  .s:mov  cl,[edx]
     inc  edx
     cmp  cl,'0'
  jae @b
ret

StrToDoubleU: ;(s: PAnsiChar): single;register;
  call     StrToUInt
  cvtsi2sd xmm0,eax
  test     cl,cl
  je @f
    mov      edi,edx
    mov      eax,edx
    call     StrToUInt
    cvtsi2sd xmm1,eax
    sub      edx,edi
    mulsd    xmm1,[.scale+edx*8-16]
    addsd    xmm0,xmm1
  @@:
ret
.scale dq 0.1,0.01,0.001,0.0001,0.00001,0.000001,0.0000001,0.00000001,0.000000001,0.0000000001

if SimulationMode=1
  SimuDeviceIoControlWrp:
    pop  [retaddr]
    call [SimuDeviceIoControl]
    add  esp,32
  jmp  [retaddr]
  retaddr rd 1
end if

align 16
data import
library kernel,'kernel32.dll',\
        user,'user32.dll',\
        SetupAPI,'SetupAPI',\
        comctl,'comctl32.dll',\
        DrvSimu,'DrvSimu.dll'

import kernel,\
       DeviceIoControl,'DeviceIoControl',\
       CreateThread,'CreateThread',\
       CreateFileW,'CreateFileW',\
       CloseHandle,'CloseHandle',\
       ExitProcess,'ExitProcess',\
       WriteFile,'WriteFile',\
       GetStdHandle,'GetStdHandle',\
       Sleep,'Sleep'

import user,\
       GetDlgItem,'GetDlgItem',\
       SendMessageA,'SendMessageA',\
       SendMessageW,'SendMessageW',\
       SetTimer,'SetTimer',\
       DialogBoxParamW,'DialogBoxParamW',\
       wsprintfA,'wsprintfA'

import SetupAPI,\
       SetupDiGetClassDevsW,'SetupDiGetClassDevsW',\
       SetupDiGetDeviceInterfaceDetailW,'SetupDiGetDeviceInterfaceDetailW',\
       SetupDiEnumDeviceInterfaces,'SetupDiEnumDeviceInterfaces',\
       SetupDiDestroyDeviceInfoList,'SetupDiDestroyDeviceInfoList'

import comctl,\
       InitCommonControls,'InitCommonControls'

if SimulationMode=1
import DrvSimu,\
       SimuDeviceIoControl,'?SimuDeviceIoControl@@YAHPAXK0K0KPAKPAU_OVERLAPPED@@@Z',\
       InstallSimuDrv,'?InstallSimuDrv@@YAPAXXZ'
end if
end data

align 16
dbl_chs                     dq 8000000000000000h,8000000000000000h
dbl_0005                    dq 0.005,0.005
dbl_0000025                 dq 0.000025,0.000025
dbl_abs                     dq 7FFFFFFFFFFFFFFFh
dbl_10000                   dq 10000.0
ON_OFF                      du 'OFF',0,'ON',0
fmt_Coord                   db 'X:%i.%i; Y:%i.%i; Z:%i.%i',0
fmt_NCCMD                   db '%-08.8X %-08.8X %-04.4X %-04.4X',13,10,0
DeviceInfoData              SP_DEVINFO_DATA sizeof.SP_DEVINFO_DATA
DeviceInterfaceData         SP_DEVICE_INTERFACE_DATA sizeof.SP_DEVICE_INTERFACE_DATA

align 16
OutPort               NCCMD 24,1,0,NCCMD_SetOutPort           ;/  (24 -  , 1 - )
SpindlePercent        NCCMD 100,0,0,NCCMD_SpindlePercent      ;   
FeedRatePercent       NCCMD 100,0,0,NCCMD_FeedratePecent      ;  
SpindleRev            NCCMD 24000,0,0,NCCMD_SpindleRev        ;   

align 16
NCParams:
 .OutPortPolarity     db 0xFF,0x00,0x00,0x00,0x00,0x00,0x00,0x00
 .InPortPolarity      db 0xFF,0xFF,0x00,0x00,0x00,0x00,0x00,0x00
 .LimitMask           db 0x0E,0x00,0x00,0x00,0x00,0x00,0x00,0x00
 .DisableLimitMask    db 0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x40
 .EStopMask           db 0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
 .EstopOutputMap      db 0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
 .ResetOutputMap      db 0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
                      db 0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
                      db 0x01,0x01,0x91,0x7C
 .XAxisDir            dd 1
 .YAxisDir            dd 1
 .ZAxisDir            dd 1
 .XEncDir             dd 1
 .YEncDir             dd 1
 .ZEncDir             dd 1
 .Feedrate            dd 100
 .SpindlePercent      dd 100
 .SpindleMaxRev       dd 24000
                      dd 0
 .XPulse              dw 400                    ; G00    0,005  (   1000 /  80     1000*80*0,005=400)
 .YPulse              dw 400
 .ZPulse              dw 400
 .XPulse2             dw 400                    ;  G01
 .YPulse2             dw 400
 .ZPulse2             dw 400
 .XAccel              dw 200                    ;    0,005 ^2   100 (   700 /^2  80      700*0,005*0,005*80*100=140)
 .YAccel              dw 200
 .ZAccel              dw 200
 .XAccel2             dw 200                    ;   
 .YAccel2             dw 200
 .ZAccel2             dw 200
                      db 0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
                      db 0x00,0x00,0x00,0x00,0x01,0x1C,0xEA,0x73,0x0A,0x00,0x00,0x00,0xFF,0xFF,0xFF,0xFF ;90h
 .ZPauseOffset        db 0x83,0x06,0x00,0x00    ; 
                      db 0x00,0x00,0x00,0x00,0x01,0x01,0x00,0x00,0x05,0x00,0x00,0x00
 .MachX               dd 0                      ;   
 .MachY               dd 0
 .MachZ               dd 0
                      db 0x01,0x00,0x00,0x00
                      db 0x01,0x00,0x00,0x00
                      db 0x01,0x00,0x00,0x00
                      db 0x01,0x00,0x00,0x00,0x01,0x00,0x00,0x00,0x01,0x00,0x00,0x00,0x01,0x00,0x00,0x00,0x01,0x00,0x00,0x00,0x01,0x00,0x00,0x00
 .MechanicalLimitMinX db 0x00,0x00,0x00,0x00    ; 
 .MechanicalLimitMinY db 0x00,0x00,0x00,0x00
 .MechanicalLimitMinZ db 0xEB,0xCB,0xFF,0xFF
 .MechanicalLimitMaxX db 0x93,0x05,0x02,0x00
 .MechanicalLimitMaxY db 0xA3,0xE2,0x03,0x00
 .MechanicalLimitMaxZ db 0x00,0x00,0x00,0x00

struct Vector4D
  x rq 1
  y rq 1
  z rq 1
  w rq 1
ends

align 16
LastDir  dd 1,1,1,1
MaxSpeed Vector4D
MinSpeed Vector4D
Pulse    Vector4D
Speed    Vector4D
Accel    Vector4D
CurFreq  Vector4D
Brake    Vector4D

hwnds:
  .button_x_plus    rd 1
  .button_x_minus   rd 1
  .button_y_plus    rd 1
  .button_y_minus   rd 1
  .button_z_plus    rd 1
  .button_z_minus   rd 1
  .trackbar_spindle rd 1
  .button_spindle   rd 1
  .edit_x_pulse     rd 1
  .edit_y_pulse     rd 1
  .edit_z_pulse     rd 1
  .edit_w_pulse     rd 1
  .edit_x_speed     rd 1
  .edit_y_speed     rd 1
  .edit_z_speed     rd 1
  .edit_w_speed     rd 1
  .edit_x_accel     rd 1
  .edit_y_accel     rd 1
  .edit_z_accel     rd 1
  .edit_w_accel     rd 1
  .button_apply     rd 1
  .radio_x          rd 1
  .radio_y          rd 1
  .radio_z          rd 1
  .count=($-hwnds)/4

DeviceInterfaceDetailData   SP_DEVICE_INTERFACE_DETAIL_DATA_W

align 16
NCCMD_FIFO        rd 1
NCStudioHandle    rd 1
i                 rd 1
con               rd 1
OutBuf            rb 4058h
Buf               rw 256